﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using _380081.Properties;

namespace _380081
{
    public partial class Form1 : Form
    {
        public Form1()
        {

            InitializeComponent();

            #region bind grid
            Random r = new Random();
            DataTable table = new DataTable();
            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Name", typeof(string));
            table.Columns.Add("Bool", typeof(bool));

            for (int i = 0; i < 250; i++)
            {
                table.Rows.Add(i, "Row " + i, r.Next(10) > 5 ? true : false);
            }

            this.radGridView1.DataSource = table;

            DataTable table2 = new DataTable();
            table2.Columns.Add("ID", typeof(int));
            table2.Columns.Add("ParentID", typeof(int));
            table2.Columns.Add("Bool", typeof(bool));

            for (int i = 1; i < 250; i++)
            {
                table2.Rows.Add(i, i, r.Next(10) > 5 ? true : false);
                table2.Rows.Add(i, i, r.Next(10) > 5 ? true : false);
                table2.Rows.Add(i, i, r.Next(10) > 5 ? true : false);
                table2.Rows.Add(i, i, r.Next(10) > 5 ? true : false);
                table2.Rows.Add(i, i, r.Next(10) > 5 ? true : false);
                table2.Rows.Add(i, i, r.Next(10) > 5 ? true : false);
            }

            GridViewTemplate template = new GridViewTemplate();
            template.DataSource = table2;
            this.radGridView1.Templates.Add(template);

            GridViewRelation relation = new GridViewRelation(this.radGridView1.MasterTemplate);
            relation.ChildTemplate = template;
            relation.ParentColumnNames.Add("ID");
            relation.ChildColumnNames.Add("ParentID");
            this.radGridView1.Relations.Add(relation);

            template.Columns.Remove(template.Columns["Bool"]);
            template.Columns.Add(new GridViewCheckBoxColumn("Bool"));
            #endregion

            radGridView1.AutoExpandGroups = true;

            radGridView1.ViewCellFormatting += new CellFormattingEventHandler(radGridView1_ViewCellFormatting);
        }

        void radGridView1_ViewCellFormatting(object sender, CellFormattingEventArgs e)
        {
            Telerik.WinControls.UI.GridGroupExpanderCellElement cell = e.CellElement as Telerik.WinControls.UI.GridGroupExpanderCellElement;

            if (e.CellElement is Telerik.WinControls.UI.GridDetailViewCellElement)
            {
                Telerik.WinControls.UI.GridDetailViewCellElement temp = e.CellElement as Telerik.WinControls.UI.GridDetailViewCellElement;
                if (temp.BorderColor != System.Drawing.Color.FromArgb(0xD4, 0xE6, 0xFC))
                {
                    temp.Padding = new Padding(40, 0, 0, 5);
                    temp.BorderBoxStyle = Telerik.WinControls.BorderBoxStyle.SingleBorder;
                    temp.BorderColor = System.Drawing.Color.FromArgb(0xD4, 0xE6, 0xFC);
                    temp.BackColor = System.Drawing.Color.FromArgb(0xD4, 0xE6, 0xFC);
                    temp.BackColor2 = System.Drawing.Color.FromArgb(0xD4, 0xE6, 0xFC);
                    temp.BackColor3 = System.Drawing.Color.White;
                    temp.BackColor4 = System.Drawing.Color.White;
                }
            }

            if (cell != null && e.CellElement.RowElement is Telerik.WinControls.UI.GridDataRowElement)
            {
                if (cell.RowInfo.ChildRows != null && cell.RowInfo.ChildRows.Count > 0)
                {
                    if (cell.RowInfo.IsExpanded == true)
                        cell.Expander.SignImage = Resources.collapse;
                    else
                        cell.Expander.SignImage = Resources.expand;
                    cell.Expander.Visibility = Telerik.WinControls.ElementVisibility.Visible;
                }
                else
                    cell.Expander.Visibility = Telerik.WinControls.ElementVisibility.Hidden;
            }
        }
    }
}
